// ---------------------------------------------------------------------------
/*
 * (c) Copyright 2010, Allan Petersen
 * ALL RIGHTS RESERVED
 * Permission to use, copy, modify, and distribute this software for
 * any purpose and without fee is hereby granted, provided that the above
 * copyright notice appear in all copies and that both the copyright notice
 * and this permission notice appear in supporting documentation, and that
 * the name of Allan Petersen not be used in advertising
 * or publicity pertaining to distribution of the software without specific,
 * written prior permission.
 *
 * THE MATERIAL EMBODIED ON THIS SOFTWARE IS PROVIDED TO YOU "AS-IS"
 * AND WITHOUT WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR OTHERWISE,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR
 * FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL ALLAN
 * PETERSEN BE LIABLE TO YOU OR ANYONE ELSE FOR ANY DIRECT,
 * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY
 * KIND, OR ANY DAMAGES WHATSOEVER, INCLUDING WITHOUT LIMITATION,
 * LOSS OF PROFIT, LOSS OF USE, SAVINGS OR REVENUE, OR THE CLAIMS OF
 * THIRD PARTIES, WHETHER OR NOT ALLAN PETERSEN HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * POSSESSION, USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * www.allanpetersen.com
 *
 * Demontration of 2D Text and 3D Text
 */
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TOpenGLAPPanel"
#pragma resource "*.dfm"
TForm1 *Form1;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	Rotation = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OpenGLAPPanel1Resize(TObject *Sender)
{
	OpenGLAPPanel1->MakeOpenGLPanelCurrent();
	if (OpenGLAPPanel1->Height == 0) // Prevent A Divide By Zero By
	{
		OpenGLAPPanel1->Height = 1; // Making Height Equal One
	}

	glViewport(0, 0, OpenGLAPPanel1->Width, OpenGLAPPanel1->Height);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OpenGLAPPanel1Paint(TObject *Sender)
{
	double 		XYZ[3];
	AnsiString	TimeStr;

	TimeStr = Now().TimeString();

	OpenGLAPPanel1->MakeOpenGLPanelCurrent();
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	// ----- 3D Text
	glPushMatrix();
	glEnable (GL_LIGHTING);
	glMatrixMode(GL_PROJECTION); // Select The Projection Matrix
	glLoadIdentity(); // Reset The Projection Matrix
	// Calculate The Aspect Ratio Of The Window
	gluPerspective(45.0f, (GLfloat)OpenGLAPPanel1->Width / (GLfloat) OpenGLAPPanel1->Height, 0.1f, 100.0f);
	glMatrixMode(GL_MODELVIEW); // Select The Modelview Matrix
	glLoadIdentity(); // Reset The Modelview Matrix
	OpenGLAPPanel1->Get3DTextSize (TimeStr.c_str(), XYZ);

	glTranslated(-XYZ[0]/2.0,-XYZ[1]/2, -2.5); // center 3D text
	glRotatef (Rotation, 1, 0, 0);   // rotate the clock
	glColor3ub(GetRValue(clBlue),
			   GetGValue(clBlue),
			   GetBValue(clBlue));
	OpenGLAPPanel1->Draw3DText(TimeStr.c_str());
	glPopMatrix();

	// ----- 2D Text
	glPushMatrix();
	glDisable (GL_LIGHTING);
	glMatrixMode(GL_PROJECTION); // Select The Projection Matrix
	glLoadIdentity(); // Reset The Projection Matrix
	glOrtho(0, OpenGLAPPanel1->Width, OpenGLAPPanel1->Height, 0, -1, 1);
	glMatrixMode(GL_MODELVIEW); // Select The Modelview Matrix
	glLoadIdentity(); // Reset The Modelview Matrix

	glColor3ub(GetRValue(clWhite),
			   GetGValue(clWhite),
			   GetBValue(clWhite));
	glRasterPos2f(5, Canvas->TextHeight(TimeStr));
	OpenGLAPPanel1->Draw2DText(TimeStr.c_str());

	glRasterPos2f(OpenGLAPPanel1->Width-Canvas->TextWidth(TimeStr)-5, Canvas->TextHeight(TimeStr));
	OpenGLAPPanel1->Draw2DText(TimeStr.c_str());

	glRasterPos2f(5, OpenGLAPPanel1->Height-5);
	OpenGLAPPanel1->Draw2DText(TimeStr.c_str());

	glRasterPos2f(OpenGLAPPanel1->Width-Canvas->TextWidth(TimeStr)-5, OpenGLAPPanel1->Height-5);
	OpenGLAPPanel1->Draw2DText(TimeStr.c_str());
	glPopMatrix();
	// -----

}
//---------------------------------------------------------------------------
void __fastcall TForm1::OpenGLAPPanel1Init(TObject *Sender)
{
	glClearColor(0.5f,0.5f,0.5f,1.0f);			// grey background
	// glClearColor(0.0f, 0.0f, 0.0f, 0.5f);			// Black Background
	glShadeModel(GL_SMOOTH);				// Enable Smooth Shading
	glClearDepth(1.0f);					// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);				// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);					// The Type Of Depth Testing To Do
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations
	glEnable(GL_LIGHT0);					// Enable Default Light (Quick And Dirty)	( NEW )
	glEnable(GL_LIGHTING);					// Enable Lighting				( NEW )
	glEnable(GL_COLOR_MATERIAL);				// Enable Coloring Of Material			( NEW )

	TimerPaint->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TimerPaintTimer(TObject *Sender)
{
	Rotation++;
	if (Rotation > 360) Rotation =  0;
	OpenGLAPPanel1->Repaint();
}
//---------------------------------------------------------------------------
